Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CIntervalManager Class Reference

This object holds a number of currently-playing intervals and is responsible for advancing them each frame as needed. More...

List of all members.

## Public Member Functions
| CIntervalManager ()
int | addCInterval (CInterval interval, bool external)
| Adds the interval to the manager, and returns a unique index for the interval.
int | findCInterval (string name)
| Returns the index associated with the named interval, if there is such an interval, or -1 if there is not.
CInterval | getCInterval (int index)
| Returns the interval associated with the given index.
EventQueue | getEventQueue ()
| Returns the custom event queue to be used for throwing done events from intervals as they finish.
int | getMaxIndex ()
| Returns one more than the largest interval index number in the manager.
int | getNextEvent ()
| This should be called by the scripting language after each call to step().
int | getNextRemoval ()
| This should be called by the scripting language after each call to step().
int | getNumIntervals ()
| Returns the number of currently active intervals.
int | interrupt ()
| Pauses or finishes (removes from the active queue) all intervals tagged with auto_pause or auto_finish set to true.
| output (ostream out)
| removeCInterval (int index)
| Removes the indicated interval from the queue immediately.
| setEventQueue (EventQueue event_queue)
| Specifies a custom event queue to be used for throwing done events from intervals as they finish.
| step ()
| This should be called every frame to do the processing for all the active intervals.
| write (ostream out)
## Static Public Member Functions
static CIntervalManager | getGlobalPtr ()
| Returns the pointer to the one global CIntervalManager object.

## Detailed Description

This object holds a number of currently-playing intervals and is responsible for advancing them each frame as needed.

There is normally only one IntervalManager object in the world, and it is the responsibility of the scripting language to call step() on this object once each frame, and to then process the events indicated by get_next_event().

It is also possible to create multiple IntervalManager objects for special needs.

## Constructor & Destructor Documentation

CIntervalManager | ( |  | ) |

## Member Function Documentation

int addCInterval | ( | CInterval | interval,
|  | bool | external
| ) |  |

Adds the interval to the manager, and returns a unique index for the interval.

This index will be unique among all the currently added intervals, but not unique across all intervals ever added to the manager. The maximum index value will never exceed the maximum number of intervals added at any given time.

If the external flag is true, the interval is understood to also be stored in the scripting language data structures. In this case, it will be available for information returned by get_next_event() and get_next_removal(). If external is false, the interval's index will never be returned by these two functions.

int findCInterval | ( | string | name | ) |

Returns the index associated with the named interval, if there is such an interval, or -1 if there is not.

CInterval getCInterval | ( | int | index | ) |

Returns the interval associated with the given index.

EventQueue getEventQueue | ( |  | ) |

Returns the custom event queue to be used for throwing done events from intervals as they finish.

static CIntervalManager getGlobalPtr | ( |  | ) | `[static]`

Returns the pointer to the one global CIntervalManager object.

int getMaxIndex | ( |  | ) |

Returns one more than the largest interval index number in the manager.

If you walk through all the values between (0, get_max_index()] and call get_c_interval() on each number, you will retrieve all of the managed intervals (and possibly a number of NULL pointers as well).

int getNextEvent | ( |  | ) |

This should be called by the scripting language after each call to step().

It returns the index number of the next interval that has events requiring servicing by the scripting language, or -1 if no more intervals have any events pending.

If this function returns something other than -1, it is the scripting language's responsibility to query the indicated interval for its next event via get_event_index(), and eventually pop_event().

Then get_next_event() should be called again until it returns -1.

int getNextRemoval | ( |  | ) |

This should be called by the scripting language after each call to step().

It returns the index number of an interval that was recently removed, or -1 if no intervals were removed.

If this returns something other than -1, the scripting language should clean up its own data structures accordingly, and then call get_next_removal() again.

int getNumIntervals | ( |  | ) |

Returns the number of currently active intervals.

int interrupt | ( |  | ) |

Pauses or finishes (removes from the active queue) all intervals tagged with auto_pause or auto_finish set to true.

These are intervals that someone fired up but won't necessarily expect to clean up; they can be interrupted at will when necessary.

Returns the number of intervals affected.

output | ( | ostream | out | ) |

removeCInterval | ( | int | index | ) |

Removes the indicated interval from the queue immediately.

It will not be returned from get_next_removal(), and none of its pending events, if any, will be returned by get_next_event().

setEventQueue | ( | EventQueue | event_queue | ) |

Specifies a custom event queue to be used for throwing done events from intervals as they finish.

If this is not specified, the global event queue is used.

The caller maintains ownership of the EventQueue object; it is the caller's responsibility to ensure that the supplied EventQueue does not destruct during the lifetime of the CIntervalManager.

step | ( |  | ) |

This should be called every frame to do the processing for all the active intervals.

It will call step_play() for each interval that has been added and that has not yet been removed.

After each call to step(), the scripting language should call get_next_event() and get_next_removal() repeatedly to process all the high-level (e.g. Python-interval-based) events and to manage the high-level list of intervals.

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties